package com.xin.shardingspherejdbcdemo.controller;

import com.google.common.collect.Lists;
import com.xin.shardingspherejdbcdemo.entity.User;
import com.xin.shardingspherejdbcdemo.service.UserService;
import com.xin.shardingspherejdbcdemo.config.util.SnowFlake;
import com.xin.shardingspherejdbcdemo.entity.vo.AjaxVo;
import com.xin.shardingspherejdbcdemo.entity.vo.PageVo;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import java.util.List;


@RestController
@RequestMapping("/user")
public class UserController {

    @Autowired
    private UserService userService;

    @PostMapping
    public AjaxVo saveUser(@RequestBody User user) {
        return AjaxVo.success(userService.save(user));
    }

    @PutMapping
    public AjaxVo update(@RequestBody User user) {
        return AjaxVo.success(userService.update(user));
    }

    @DeleteMapping("/{id}")
    public AjaxVo delete(@PathVariable Long id) {
        return AjaxVo.success(userService.delete(id));
    }

    @GetMapping("/{id}")
    public AjaxVo info(@PathVariable Long id) {
        return AjaxVo.success(userService.info(id));
    }

    @PostMapping("/insertlist")
    public AjaxVo insertlist() {
        List<User> userList = Lists.newArrayList();
        SnowFlake snowFlake = new SnowFlake(2, 3);
        for (int i = 0; i < 100000; i++) {
            userList.add(new User(snowFlake.nextId(), "用户", 18 + i));
        }
        userService.saveList(userList);
        return AjaxVo.success();
    }

    @GetMapping("/list")
    public AjaxVo listUser(int pageNum, int pageSize, String name, Integer age) {
        PageVo data = userService.list(pageNum, pageSize, name, age);
        return AjaxVo.success(data);
    }

}

